SimpleMappingExceptionResolver (Spring Framework 3.2.1.RELEASE API)
Date: 2013-01-24

org.springframework.web.portlet.handler

## Class SimpleMappingExceptionResolver

- java.lang.Object
- - org.springframework.web.portlet.handler.AbstractHandlerExceptionResolver
  - - org.springframework.web.portlet.handler.SimpleMappingExceptionResolver

- All Implemented Interfaces:
    Ordered, HandlerExceptionResolver

      public class SimpleMappingExceptionResolver
      extends AbstractHandlerExceptionResolver

  `HandlerExceptionResolver` implementation that allows for mapping exception class names to view names, either for a set of given handlers or for all handlers in the DispatcherPortlet.

  Error views are analogous to error page JSPs, but can be used with any kind of exception including any checked one, with fine-granular mappings for specific handlers.

  Since:
    2.0
  Author:
    Juergen Hoeller, John A. Lewis, Arjen Poutsma

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static String` | `DEFAULT_EXCEPTION_ATTRIBUTE` The default name of the exception attribute: "exception".

    - ### Fields inherited from class org.springframework.web.portlet.handler.AbstractHandlerExceptionResolver

      `logger`

    - ### Fields inherited from interface org.springframework.core.Ordered

      `HIGHEST_PRECEDENCE, LOWEST_PRECEDENCE`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `SimpleMappingExceptionResolver()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected String` | `determineViewName(Exception ex, PortletRequest request)` Determine the view name for the given exception, searching the `"exceptionMappings"`, using the `"defaultErrorView"` as fallback.
    `protected ModelAndView` | `doResolveException(PortletRequest request, MimeResponse response, Object handler, Exception ex)` Actually resolve the given exception that got thrown during on handler execution, returning a ModelAndView that represents a specific error page if appropriate.
    `protected String` | `findMatchingViewName(Properties exceptionMappings, Exception ex)` Find a matching view name in the given exception mappings
    `protected int` | `getDepth(String exceptionMapping, Exception ex)` Return the depth to the superclass matching.
    `protected ModelAndView` | `getModelAndView(String viewName, Exception ex)` Return a ModelAndView for the given view name and exception.
    `protected ModelAndView` | `getModelAndView(String viewName, Exception ex, PortletRequest request)` Return a ModelAndView for the given request, view name and exception.
    `void` | `setDefaultErrorView(String defaultErrorView)` Set the name of the default error view.
    `void` | `setExceptionAttribute(String exceptionAttribute)` Set the name of the model attribute as which the exception should be exposed.
    `void` | `setExceptionMappings(Properties mappings)` Set the mappings between exception class names and error view names.

    - ### Methods inherited from class org.springframework.web.portlet.handler.AbstractHandlerExceptionResolver

      `buildLogMessage, getOrder, logException, resolveException, resolveException, setMappedHandlerClasses, setMappedHandlers, setOrder, setRenderWhenMinimized, setWarnLogCategory, shouldApplyTo`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### DEFAULT_EXCEPTION_ATTRIBUTE

          public static final String DEFAULT_EXCEPTION_ATTRIBUTE

      The default name of the exception attribute: "exception".
      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### SimpleMappingExceptionResolver

          public SimpleMappingExceptionResolver()

  - ### Method Detail

    - #### setExceptionMappings

          public void setExceptionMappings(Properties mappings)

      Set the mappings between exception class names and error view names. The exception class name can be a substring, with no wildcard support at present. A value of "PortletException" would match `javax.portet.PortletException` and subclasses, for example.

      NB: Consider carefully how specific the pattern is, and whether to include package information (which isn't mandatory). For example, "Exception" will match nearly anything, and will probably hide other rules. "java.lang.Exception" would be correct if "Exception" was meant to define a rule for all checked exceptions. With more unusual exception names such as "BaseBusinessException" there's no need to use a FQN.

      Follows the same matching algorithm as RuleBasedTransactionAttribute and RollbackRuleAttribute.

      Parameters:
        `mappings` - exception patterns (can also be fully qualified class names) as keys, and error view names as values
      See Also:
        `RuleBasedTransactionAttribute`, `RollbackRuleAttribute`

    - #### setDefaultErrorView

          public void setDefaultErrorView(String defaultErrorView)

      Set the name of the default error view. This view will be returned if no specific mapping was found.

      Default is none.

    - #### setExceptionAttribute

          public void setExceptionAttribute(String exceptionAttribute)

      Set the name of the model attribute as which the exception should be exposed. Default is "exception".
      See Also:
        `DEFAULT_EXCEPTION_ATTRIBUTE`

    - #### doResolveException

          protected ModelAndView doResolveException(PortletRequest request,
                                        MimeResponse response,
                                        Object handler,
                                        Exception ex)

      Actually resolve the given exception that got thrown during on handler execution, returning a ModelAndView that represents a specific error page if appropriate.
      Specified by:
        `doResolveException` in class `AbstractHandlerExceptionResolver`
      Parameters:
        `request` - current portlet request
        `response` - current portlet response
        `handler` - the executed handler, or null if none chosen at the time of the exception (for example, if multipart resolution failed)
        `ex` - the exception that got thrown during handler execution
      Returns:
        a corresponding ModelAndView to forward to, or null for default processing

    - #### determineViewName

          protected String determineViewName(Exception ex,
                                 PortletRequest request)

      Determine the view name for the given exception, searching the `"exceptionMappings"`, using the `"defaultErrorView"` as fallback.
      Parameters:
        `ex` - the exception that got thrown during handler execution
        `request` - current portlet request (useful for obtaining metadata)
      Returns:
        the resolved view name, or `null` if none found

    - #### findMatchingViewName

          protected String findMatchingViewName(Properties exceptionMappings,
                                    Exception ex)

      Find a matching view name in the given exception mappings
      Parameters:
        `exceptionMappings` - mappings between exception class names and error view names
        `ex` - the exception that got thrown during handler execution
      Returns:
        the view name, or `null` if none found
      See Also:
        `setExceptionMappings(java.util.Properties)`

    - #### getDepth

          protected int getDepth(String exceptionMapping,
                     Exception ex)

      Return the depth to the superclass matching.

      0 means ex matches exactly. Returns -1 if there's no match. Otherwise, returns depth. Lowest depth wins.

      Follows the same algorithm as `RollbackRuleAttribute`.

    - #### getModelAndView

          protected ModelAndView getModelAndView(String viewName,
                                     Exception ex,
                                     PortletRequest request)

      Return a ModelAndView for the given request, view name and exception. Default implementation delegates to `getModelAndView(viewName, ex)`.
      Parameters:
        `viewName` - the name of the error view
        `ex` - the exception that got thrown during handler execution
        `request` - current portlet request (useful for obtaining metadata)
      Returns:
        the ModelAndView instance
      See Also:
        `getModelAndView(String, Exception)`

    - #### getModelAndView

          protected ModelAndView getModelAndView(String viewName,
                                     Exception ex)

      Return a ModelAndView for the given view name and exception. Default implementation adds the specified exception attribute. Can be overridden in subclasses.
      Parameters:
        `viewName` - the name of the error view
        `ex` - the exception that got thrown during handler execution
      Returns:
        the ModelAndView instance
      See Also:
        `setExceptionAttribute(java.lang.String)`